#ifndef __PLATFORM_COMMON_H__
#define __PLATFORM_COMMON_H__	1

#include <linux/compiler.h>
#include <linux/stddef.h>
#include <linux/kernel.h>
#include <linux/slab.h>
#include <linux/i2c.h>

/* arch independent definitions */
#define COMM_MAX_RANK	16
#define COMM_MAX_DIMM	16
#define COMM_MAX_CH		16
#define COMM_MAX_IMC	16
#define COMM_MAX_SOCKET	16

#define RCD_DEV_VENDOR(vid_high, vid_low)	((vid_high) << 0x10 | (vid_low))

/*
*	definitions of SPD
*/
#define SPA0_SLAVE	0x6c
#define SPA1_SLAVE	0x6e
#define SPD_SLAVE	0xa0

#define SPD_PAGE_SIZE	256

extern int platform_none_secure_env;

#if 0
struct dimm_device{
	int dimm_slot;
	unsigned int device_id;
	unsigned int vendor_id;
	int spd_slave, rcd_slave;
	struct list_head node;

	atomic_t private_lock;
	void *private_data;
};
#define dimm_device_of(node)	container_of((node), struct dimm_device, node)

static inline struct dimm_device *alloc_dimm_device(int dimm_slot,
							unsigned int device_id, unsigned int vendor_id,
							int spd_slave, int rcd_slave){
	struct dimm_device *dimm_dev = NULL;
	dimm_dev = kzalloc(sizeof(*dimm_dev), GFP_KERNEL);
	if (unlikely(dimm_dev == NULL)){
		return NULL;
	}

	dimm_dev->dimm_slot = dimm_slot;
	dimm_dev->device_id = device_id;
	dimm_dev->vendor_id = vendor_id;
	dimm_dev->spd_slave = spd_slave;
	dimm_dev->rcd_slave = rcd_slave;

	atomic_set(&(dimm_dev->private_lock), 0);
	dimm_dev->private_data = NULL;

	INIT_LIST_HEAD(&(dimm_dev->node));

	return dimm_dev;
}

static inline void free_dimm_dev(struct dimm_device *dimm_dev){
	/* check if the node is deleted from the list */
	if (list_empty(&(dimm_dev->node))){
		list_del(&(dimm_dev->node));
	}

	kfree(dimm_dev);
}
#endif

extern int platform_init(void);
extern void platform_exit(void);

extern int platform_foreach_online_dimm(void *arg,
								int (*handler)(struct list_head *node, void *arg));


extern int platform_get_mem_cfg_mode(void);

struct rcd_device;
extern struct i2c_adapter *platform_get_rcd_dev_adapter(struct rcd_device *rcd_dev);

extern int platform_system_range_decode(unsigned long sys_start, unsigned long sys_end,
											struct list_head *rcd_rule_head);

extern int platform_update_vma_writable(struct vm_area_struct *vma);
#endif
